
using System;
using Microsoft.ReportingServices.DataProcessing;
using System.Collections;
using System.Globalization;
using System.Diagnostics;

namespace Macaw.ReportingServices.SharepointListExtension
{
	/// <summary>
	/// DataParameterCollection is a very simple typed collection of IDataParameter's
	/// </summary>
	public class DataParameterCollection : CollectionBase, IDataParameterCollection
	{
		public IDataParameter this[int index]
		{
			get{return (IDataParameter)InnerList[index];}
		}
		public IDataParameter this[string name]
		{
			get{return GetByName(name);}
		}
		public int  Add(IDataParameter param)
		{
			return InnerList.Add(param);
		}
		public void Remove(IDataParameter param)
		{
			InnerList.Remove(param);
		}

		#region Strong types parameters

		public string SiteUrl
		{
			get
			{
				IDataParameter Param = GetByName("SiteUrl");
				if(Param == null || Param.Value == null || Param.Value == DBNull.Value || (string)Param.Value == "" )
				{
					return "";
				}
				string result = (string)Param.Value;
				if(!result.EndsWith("/"))result += "/";
				return result;
			}
		}

		private IDataParameter GetByName(string name)
		{
			IDataParameter Param =null;
			foreach(IDataParameter par in InnerList)
			{
				if(par.ParameterName == name)Param = par;
			}
			return Param;
		}

		#endregion

	}
}

